﻿@model List<ControleEstoque.Web.Models.GrupoProdutoModel>
@{
    ViewBag.Title = "Cadastro de Grupo de Produtos";
}
<style>
    #grid_cadastro > thead > tr th:nth-child(2) {
        width: 110px;
    }

    #grid_cadastro > thead > tr th:nth-child(3) {
        width: 200px;
    }

    #cadastro {
        width: 70%;
        margin: 0 auto;
    }

    #cadastro_cabecalho {
        border-bottom: 1px #dddddd solid;
    }

    #cadastro_conteudo {
        margin-top: 20px;
    }

    #cabecalho_grid {
        margin-bottom: 20px;
    }

    #modal_cadastro {
        width: 200px;
        margin: auto;
    }
</style>
<div id="cadastro">
    <section id="cadastro_cabecalho">
        <h1>@ViewBag.Title</h1>
    </section>
    <section id="cadastro_conteudo">
        <div id="cabecalho_grid" class="row">
            <div class="col-md-12">
                <a id="btn_incluir" class="btn btn-success" role="button"><i class="glyphicon glyphicon-plus"></i> Incluir</a>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <table id="grid_cadastro" class="table table-bordered table-striped table-hover">
                    <thead>
                        <tr></tr>
                    <th>Nome</th>
                    <th>Ativo</th>
                    <th>Ação</th>
                    </thead>
                    <tbody>
                        @foreach (var item in Model) {
                            <tr data-id="@item.Id">
                                <td>@item.Nome</td>
                                <td>@{var ativo = (item.Ativo ? "SIM" : "NÃO"); }@ativo</td>
                                <td>
                                    <a class="btn btn-primary btn-alterar" role="button"><i class="glyphicon glyphicon-pencil"></i> Alterar</a>
                                    <a class="btn btn-danger btn-excluir" role="button"><i class="glyphicon glyphicon-trash"></i> Excluir</a>
                                </td>
                            </tr>
                        }
                    </tbody>
                </table>
            </div>
        </div>
    </section>
</div>
@Html.Hidden("id_cadastro");
<div id="modal_cadastro" class="form-horizontal invisivel" role="dialog">
    <div id="msg_mensagem_aviso" class="text-danger invisivel"></div>
    <fieldset>
        <div class="row">
            <div class="form-group">
                @Html.Label("txt_nome", "Nome", new { @class = "col-md-3 control-label" })
                <div class="col-md-12">
                    @Html.TextBox("txt_nome", null, new { @class = "form-control" })
                </div>
            </div>
            <div class="form-group">
                @Html.Label("cbx_ativo", "Ativo", new { @class = "col-md-3 control-label" })
                <div class="col-md-12">
                    @Html.CheckBox("cbx_ativo")
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <div class="form-group">
                    <div class="modal-footer">
                        <a id="btn_sair" class="btn btn-default" role="button" data-dismiss="modal"><i class="glyphicon glyphicon-remove"></i> Sair</a>
                        <a id="btn_confirmar" class="btn btn-primary" role="button"><i class="glyphicon glyphicon-ok"></i> Salvar</a>
                    </div>
                    <div id="msg_aviso" class="alert alert-warning invisivel">Falta preencher os campus acima.</div>
                     <div id="msg_erro" class="alert alert-danger invisible">Ocorreu algum erro.</div>
                </div>
            </div>
        </div>
    </fieldset>
</div>
@section Scripts{
    <script>
        function abrir_form(dados) {
            $('#id_cadastro').val(dados.Id);
            $('#txt_nome').val(dados.Nome);
            $('#cbx_ativo').prop('checked', dados .Ativo);

            var model_cadastro = $('#modal_cadastro');

            bootbox.dialog({
                title: '@ViewBag.Title',
                message: model_cadastro
            })
                .on('shown.bs.modal', function () {
                    model_cadastro.show(0, function () {
                        $('#txt_nome').focus();
                    });
                })
                .on('hidden.bs.modal', function () {
                    model_cadastro.hide().appendTo('body');
                });
        }

        function criar_linha_grid(dados){
            var ret=
                '<tr data-id='+ dados.Id+'>'+
                '<td>'+dados.Nome+'</td>'+
                '<td>'+(dados.Ativo ? 'SIM' : 'NÃO')+ '</td>'+
                '<td>'+
                '<a class="btn btn-primary btn-alterar" role="button" style="margin-right: 3px"><i class="glyphicon glyphicon-pencil"></i> Alterar</a>'+
                '<a class="btn btn-danger btn-excluir" role="button"><i class="glyphicon glyphicon-trash"></i> Excluir</a>'+
                '</td>'+
                '</tr>';            
            return ret;
        }

        $(document).on('click', '#btn_incluir', function () {
            abrir_form({ Id: 0, Nome: '', Ativo: true });
        })
            .on('click', '.btn-alterar', function () {
                var btn = $(this),
                    id = btn.closest('tr').attr('data-id'),
                url = '@Url.Action("RecuperarGrupoProduto","Cadastro")';
                param = {'id':id};

                $.post(url, param, function (response) {
                    if (response) {
                        abrir_form(response);
                    }
                });
            })
            .on('click', '.btn-excluir', function () {
                var btn = $(this),
                    tr = btn.closest( 'tr' ),
                    id=tr.attr( 'data-id' ),
                    url = '@Url.Action("ExcluirGrupoProduto","Cadastro")';
                    param = {'id':id};

                bootbox.confirm( {
                    message: "Realmente deseja excluir o grupo de produto?",
                    buttons: {
                        confirm: {
                            label: 'Sim',
                            className: 'btn-success'
                        },
                        cancel: {
                            label: 'Não',
                            className: 'btn-danger'
                        }
                    },
                    callback: function (result) {
                        if (result){
                            $.post(url, param, function (response) {
                                if (response) {
                                    tr.remove();
                                }
                            });
                        }
                    }
                });
            })
            .on('click','#btn_confirmar',function(){
                var btn = $(this),
                url = '@Url.Action("SalvarGrupoProduto","Cadastro")',
                param = {
                    Id:$('#id_cadastro').val(),
                    Nome:$('#txt_nome').val(),
                    Ativo:$('#cbx_ativo').prop('checked')
                };

                $.post(url, param, function (response) {
                    if (response.Resultado == "OK") {
                        if(param.Id==0){
                            param.Id=response.IdSalvo;
                            var table=$('#grid_cadastro').find('tbody'), 
                                linha= criar_linha_grid(param);
                            table.append(linha);
                        }
                        else{
                            var linha =$('#grid_cadastro').find('tr[data-id='+param.Id+']').find('td');
                            linha
                                .eq(0).html(param.Nome).end()
                                .eq(1).html(param.Ativo ? 'SIM' : 'NÃO');
                        }
                        $('#modal_cadastro').parents('.bootbox').modal('hide');
                    }
                    else if(response.Resultado=="ERRO"){
                        $('#msg_aviso').hide();
                        $('#msg_mensagem_aviso').hide();
                        $('#msg_erro').show();
                    }
                    else if(response.Resultado=="AVISO"){
                        $('#msg_mensagem_aviso').append(formatar_mensagem_aviso(response.Mensagens));                      
                        $('#msg_aviso').show();
                        $('#msg_mensagem_aviso').show();
                        $('#msg_erro').hide();
                    }
                });
            });
            function formatar_mensagem_aviso(mensagens){
                var ret='';
                for(var i=0;i<mensagens.length; i++){
                     
                }
            }
    </script>
}